package de.andrena.objektforum.timeconcepts;

import static de.andrena.objektforum.timeconcepts.Util.formatInstant;
import static de.andrena.objektforum.timeconcepts.Util.formatLocalDateTime;
import static java.time.temporal.ChronoUnit.MINUTES;

import java.time.Instant;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.ZonedDateTime;

import org.junit.jupiter.api.Test;

public class SummerTime {

    @Test
    void switchToSummerTime() {
        ZonedDateTime oneMinuteBeforeSwitchInGermany = LocalDateTime.of(2020, 3, 29, 1, 59, 0, 0)
            .atZone(ZoneId.of("Europe/Berlin"));
        LocalDateTime pureDateTime = oneMinuteBeforeSwitchInGermany.toLocalDateTime();
        Instant asInstant = oneMinuteBeforeSwitchInGermany.toInstant();

        System.out.println(formatLocalDateTime(pureDateTime));
        System.out.println(formatLocalDateTime(pureDateTime.plus(2, MINUTES)));

        System.out.println();
        System.out.println(formatInstant(asInstant));
        System.out.println(formatInstant(asInstant.plus(2, MINUTES)));

        System.out.println();
        System.out.println(oneMinuteBeforeSwitchInGermany);
        System.out.println(oneMinuteBeforeSwitchInGermany.plus(2, MINUTES));
    }
}
